<?php

/**
 * Erpal Reports entity UI controller class.
 */
class ErpalReportsUIController extends EntityDefaultUIController {

  public function hook_menu() {
    $items = parent::hook_menu();
    $items[$this->path]['description'] = 'Manage Erpal Reports type, including fields.';

    // @todo - this part will be useful for entities without bundle support.
    /*$wildcard = isset($this->entityInfo['admin ui']['menu wildcard']) ? $this->entityInfo['admin ui']['menu wildcard'] : '%entity_object';

    $include = array(
      'file' => 'erpal_reports.pages.inc',
      'file path' => drupal_get_path('module', 'erpal_reports') . '/includes',
    );
    $items[$this->path . '/add'] += $include;
    $items[$this->path . '/manage/' . $wildcard] += $include;
    $items[$this->path . '/manage/' . $wildcard . '/edit'] += $include;*/

    return $items;
  }

}

/**
 * Generates the Erpal Reports type editing form.
 */
function erpal_reports_type_form($form, &$form_state, $erpal_reports_type, $op = 'edit') {
  if ($op == 'clone') {
    $erpal_reports_type->type .= '_clone';
  }

  // Human-readable type name.
  $form['name'] = array(
    '#title' => t('Human readable name'),
    '#type' => 'textfield',
    '#default_value' => isset($erpal_reports_type->name) ? $erpal_reports_type->name : '',
    '#description' => t('A human-readable name for this Erpal Reports type.'),
  );

  // Machine-readable type name.
  $form['type'] = array(
    '#type' => 'machine_name',
    '#default_value' => isset($erpal_reports_type->type) ? $erpal_reports_type->type : '',
    '#disabled' => entity_has_status('erpal_reports_type', $erpal_reports_type, ENTITY_IN_CODE),
    '#machine_name' => array(
      'exists' => 'erpal_reports_type_load',
    ),
    '#description' => t('A unique machine-readable name for this Erpal Reports type. It must only contain lowercase letters, numbers, and underscores.'),
  );

  field_attach_form('erpal_reports_type', $erpal_reports_type, $form, $form_state);

  $form['actions'] = array('#type' => 'actions');
  $form['actions']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save Erpal Reports type'),
    '#weight' => 40,
  );

  if (!entity_has_status('erpal_reports_type', $erpal_reports_type, ENTITY_IN_CODE) && $op != 'add') {
    $form['actions']['delete'] = array(
      '#type' => 'submit',
      '#value' => t('Delete Erpal Reports type'),
      '#weight' => 45,
      '#limit_validation_errors' => array(),
      '#submit' => array('erpal_reports_type_form_submit_delete')
    );
  }
  return $form;
}

/**
 * Validation callback.
 */
function erpal_reports_type_form_validate($form, &$form_state) {
  entity_form_field_validate('erpal_reports_type', $form, $form_state);
}

/**
 * Form API submit callback for the type form.
 */
function erpal_reports_type_form_submit(&$form, &$form_state) {
  $erpal_reports_type = entity_ui_form_submit_build_entity($form, $form_state);
  // Save and go back.
  $erpal_reports_type->save();
  $form_state['redirect'] = 'admin/structure/erpal/reports';
}

/**
 * Form API submit callback for the delete button.
 */
function erpal_reports_type_form_submit_delete(&$form, &$form_state) {
  $form_state['redirect'] = 'admin/structure/erpal/reports/manage/' . $form_state['erpal_reports_type']->type . '/delete';
}
