<?php
/**
 * @file
 * Contains Views controller for the Erpal Reports entity.
 */

/**
 * Views controller class for the Erpal Reports entity.
 */
class ErpalReportsViewsController extends EntityDefaultViewsController {

  /**
   * Overrides EntityDefaultViewsController::views_data().
   */
  public function views_data() {
    $data = parent::views_data();

    $data['erpal_reports']['operations'] = array(
      'title' => t('Operations'),
      'help' => t('Displays action operations which are available for Erpal Reports.'),
      'real field' => 'id',
      'field' => array(
        'handler' => 'erpal_reports_handler_field_operations',
      ),
    );

    return $data;
  }

}

/**
 * Implements hook_views_default_views().
 */
function erpal_reports_views_default_views() {
  return erpal_reports_exports('erpal_reports', 'views', 'view.inc', 'view');
}
